SemanticVersion::Prerelease - Crystal 1.20.3

# struct SemanticVersion::Prerelease

- SemanticVersion::Prerelease
- Struct
- Value
- Object

##
Overview

Contains the pre-release version related to this semantic version

##
Included Modules

- Comparable(SemanticVersion::Prerelease)

##
Defined in:

semantic_version.cr

##
Constructors

- .new(identifiers : Array(String | Int32) = [] of String | Int32)

  Creates a new `Prerelease` instance with supplied array of identifiers

- .parse(str : String) : self

  Parses a `Prerelease` from the given pre-release version string

##
Instance Method Summary

- #<=>(other : self) : Int32

  The comparison operator.

- #identifiers : Array(String | Int32)

  Array of identifiers that make up the pre-release metadata

- #to_s(io : IO) : Nil

  Returns the string representation of this semantic version's pre-release metadata

### Instance methods inherited from module `Comparable(SemanticVersion::Prerelease)`

<(other : T) : Bool <, <=(other : T) <=, <=>(other : T) <=>, ==(other : T) ==, >(other : T) : Bool >, >=(other : T) >=, clamp(min, max)
clamp(range : Range) clamp

### Instance methods inherited from struct `Struct`

==(other : YAML::Any)
==(other) : Bool ==, hash(hasher) hash, inspect(io : IO) : Nil inspect, pretty_print(pp) : Nil pretty_print, to_s(io : IO) : Nil to_s

### Class methods inherited from struct `Struct`

pre_initialize(address : Pointer) : Nil pre_initialize

### Instance methods inherited from struct `Value`

==(other : Log::Metadata::Value)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io : String | IO, root : String)
from_json(string_or_io : String | IO) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Constructor Detail

def self.new(identifiers : Array(String | Int32) = [] of String | Int32) #

Creates a new `Prerelease` instance with supplied array of identifiers

def self.parse(str : String) : self #

Parses a `Prerelease` from the given pre-release version string

    require "semantic_version"

    prerelease = SemanticVersion::Prerelease.parse("rc.1.3")
    prerelease # => SemanticVersion::Prerelease(@identifiers=["rc", 1, 3])

##
Instance Method Detail

def <=>(other : self) : Int32 #

The comparison operator.

Returns `-1`, `0` or `1` depending on whether `self`'s pre-release is lower than other's, equal to other's pre-release or greater than other's pre-release.

    require "semantic_version"

    prerelease1 = SemanticVersion::Prerelease.new(["rc", 1])
    prerelease2 = SemanticVersion::Prerelease.new(["rc", 1, 2])

    prerelease1 <=> prerelease2 # => -1
    prerelease1 <=> prerelease1 # => 0
    prerelease2 <=> prerelease1 # => 1

def identifiers : Array(String | Int32) #

Array of identifiers that make up the pre-release metadata

def to_s(io : IO) : Nil #

Returns the string representation of this semantic version's pre-release metadata

    require "semantic_version"

    semver = SemanticVersion.parse("0.27.1-rc.1")
    semver.prerelease.to_s # => "rc.1"